Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QAbstractItemView

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QWidget
                          com.trolltech.qt.gui.QFrame
                              com.trolltech.qt.gui.QAbstractScrollArea
                                  com.trolltech.qt.gui.QAbstractItemView

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

Direct Known Subclasses:
  QColumnView, QHeaderView, QListView, QTableView, QTreeView

    public abstract class QAbstractItemView

extends QAbstractScrollArea

The `QAbstractItemView` class provides the basic functionality for item view classes. `QAbstractItemView` class is the base class for every standard view that uses a `QAbstractItemModel`. `QAbstractItemView` is an abstract class and cannot itself be instantiated. It provides a standard interface for interoperating with models through the signals and slots mechanism, enabling subclasses to be kept up-to-date with changes to their models. This class provides standard support for keyboard and mouse navigation, viewport scrolling, item editing, and selections.

The `QAbstractItemView` class is one of the Model/View Classes and is part of Qt's model/view framework.

The view classes that inherit `QAbstractItemView` only need to implement their own view-specific functionality, such as drawing items, returning the geometry of items, finding items, etc.

`QAbstractItemView` provides common slots such as `edit()` and `setCurrentIndex()`. Many protected slots are also provided, including `dataChanged()`, `rowsInserted()`, `rowsAboutToBeRemoved()`, `selectionChanged()`, and `currentChanged()`.

The root item is returned by `rootIndex()`, and the current item by `currentIndex()`. To make sure that an item is visible use `scrollTo()`.

Some of `QAbstractItemView`'s functions are concerned with scrolling, for example `setHorizontalScrollMode()` and `setVerticalScrollMode()`. To set the range of the scroll bars, you can, for example, reimplement the view's `resizeEvent()` function:
The following code example is written in c++.

            void MyView::resizeEvent(QResizeEvent *event) {
                horizontalScrollBar()->setRange(0, realWidth - width());
                ...
            }

Note that the range is not updated until the widget is shown.

Several other functions are concerned with selection control; for example `setSelectionMode()`, and `setSelectionBehavior()`. This class provides a default selection model to work with (`selectionModel()`), but this can be replaced by using `setSelectionModel()` with an instance of `QItemSelectionModel`.

For complete control over the display and editing of items you can specify a delegate with `setItemDelegate()`.

`QAbstractItemView` provides a lot of protected functions. Some are concerned with editing, for example, `edit()`, and `commitData()`, whilst others are keyboard and mouse event handlers.

Note: If you inherit `QAbstractItemView` and intend to update the contents of the viewport, you should use viewport->`update()` instead of `update()` as all painting operations take place on the viewport.

See also:
  View Classes, Model/View Programming, `QAbstractItemModel`, and Chart Example.

Nested Class Summary
`static class` | `QAbstractItemView.CursorAction`
`static class` | `QAbstractItemView.DragDropMode` Describes the various drag and drop events the view can act upon.
`static class` | `QAbstractItemView.DropIndicatorPosition` This enum indicates the position of the drop indicator in relation to the index at the current mouse position.
`static class` | `QAbstractItemView.EditTrigger` This enum describes actions which will initiate item editing.
`static class` | `QAbstractItemView.EditTriggers` This is a flags class for com.trolltech.qt.gui.QAbstractItemView.EditTrigger
`static class` | `QAbstractItemView.ScrollHint`
`static class` | `QAbstractItemView.ScrollMode`
`static class` | `QAbstractItemView.SelectionBehavior`
`static class` | `QAbstractItemView.SelectionMode` This enum describes the types of selection offered to the user for selecting dates in the calendar.
`static class` | `QAbstractItemView.State` This enum describes the state of a window.

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QFrame
`QFrame.Shadow, QFrame.Shape, QFrame.StyleMask`

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal1` | `activated` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `clicked` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `doubleClicked` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `entered` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `pressed` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal0` | `viewportEntered` This signal is emitted when the mouse cursor enters the viewport.

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QAbstractItemView()` Constructs an abstract item view with the given `parent`.
`QAbstractItemView(QWidget parent)` Constructs an abstract item view with the given `parent`.

Method Summary
`boolean` | `alternatingRowColors()` This property holds whether to draw the background using alternating colors.
`int` | `autoScrollMargin()` This property holds the size of the area when auto scrolling is triggered.
`void` | `clearSelection()` Deselects all selected items.
`protected void` | `closeEditor(QWidget editor, QAbstractItemDelegate.EndEditHint hint)` Closes the given `editor`, and releases it.
`void` | `closePersistentEditor(com.trolltech.qt.core.QModelIndex index)` Closes the persistent editor for the item at the given `index`.
`protected void` | `commitData(QWidget editor)` Commit the data in the `editor` to the model.
`protected void` | `currentChanged(com.trolltech.qt.core.QModelIndex current, com.trolltech.qt.core.QModelIndex previous)` This slot is called when a new item becomes the current item.
`com.trolltech.qt.core.QModelIndex` | `currentIndex()` Returns the model index of the current item.
`protected void` | `dataChanged(com.trolltech.qt.core.QModelIndex topLeft, com.trolltech.qt.core.QModelIndex bottomRight)` This slot is called when items are changed in the model.
`protected QPoint` | `dirtyRegionOffset()` Returns the offset of the dirty regions in the view.
`QAbstractItemView.DragDropMode` | `dragDropMode()` This property holds the drag and drop event the view will act upon.
`boolean` | `dragDropOverwriteMode()` This property holds the view's drag and drop behavior.
`boolean` | `dragEnabled()` This property holds whether the view supports dragging of its own items.
`protected QAbstractItemView.DropIndicatorPosition` | `dropIndicatorPosition()` Returns the position of the drop indicator in relation to the closest item.
`void` | `edit(com.trolltech.qt.core.QModelIndex index)` Starts editing the item corresponding to the given `index` if it is editable.
`protected boolean` | `edit(com.trolltech.qt.core.QModelIndex index, QAbstractItemView.EditTrigger trigger, QEvent event)` Starts editing the item at `index`, creating an editor if necessary, and returns true if the view's `State` is now `EditingState` ; otherwise returns false.
`protected void` | `editorDestroyed(QObject editor)` This function is called when the given `editor` has been destroyed.
`QAbstractItemView.EditTriggers` | `editTriggers()` This property holds which actions will initiate item editing.
`protected void` | `executeDelayedItemsLayout()` Executes the scheduled layouts without waiting for the event processing to begin.
`boolean` | `hasAutoScroll()` This property holds whether autoscrolling in drag move events is enabled.
`protected abstract int` | `horizontalOffset()` Returns the horizontal offset of the view.
`QAbstractItemView.ScrollMode` | `horizontalScrollMode()` This property holds how the view scrolls its contents in the horizontal direction.
`QSize` | `iconSize()` This property holds the size of items.
`abstract com.trolltech.qt.core.QModelIndex` | `indexAt(QPoint point)` Returns the model index of the item at the viewport coordinates `point`.
`QWidget` | `indexWidget(com.trolltech.qt.core.QModelIndex index)` Returns the widget for the item at the given `index`.
`protected abstract boolean` | `isIndexHidden(com.trolltech.qt.core.QModelIndex index)` Returns true if the item referred to by the given `index` is hidden in the view, otherwise returns false.
`QAbstractItemDelegate` | `itemDelegate()` Returns the item delegate used by this view and model.
`QAbstractItemDelegate` | `itemDelegate(com.trolltech.qt.core.QModelIndex index)` Returns the item delegate used by this view and model for the given `index`.
`QAbstractItemDelegate` | `itemDelegateForColumn(int column)` Returns the item delegate used by this view and model for the given `column`.
`QAbstractItemDelegate` | `itemDelegateForRow(int row)` Returns the item delegate used by this view and model for the given `row`, or 0 if no delegate has been assigned.
`void` | `keyboardSearch(java.lang.String search)` Moves to and selects the item best matching the string `search`.
`QAbstractItemModel` | `model()` Returns the model that this view is presenting.
`protected abstract com.trolltech.qt.core.QModelIndex` | `moveCursor(QAbstractItemView.CursorAction cursorAction, Qt.KeyboardModifiers modifiers)` Returns a QModelIndex object pointing to the next object in the view, based on the given `cursorAction` and keyboard modifiers specified by `modifiers`.
`void` | `openPersistentEditor(com.trolltech.qt.core.QModelIndex index)` Opens a persistent editor on the item at the given `index`.
`void` | `reset()` Reset the internal state of the view.
`com.trolltech.qt.core.QModelIndex` | `rootIndex()` Returns the model index of the model's root item.
`protected void` | `rowsAboutToBeRemoved(com.trolltech.qt.core.QModelIndex parent, int start, int end)` This slot is called when rows are about to be removed.
`protected void` | `rowsInserted(com.trolltech.qt.core.QModelIndex parent, int start, int end)` This slot is called when rows are inserted.
`protected void` | `scheduleDelayedItemsLayout()` Schedules a layout of the items in the view to be executed when the event processing starts.
`protected void` | `scrollDirtyRegion(int dx, int dy)` Prepares the view for scrolling by (`dx`,`dy`) pixels by moving the dirty regions in the opposite direction.
`void` | `scrollTo(com.trolltech.qt.core.QModelIndex index)` Scrolls the view if necessary to ensure that the item at `index` is visible.
`abstract void` | `scrollTo(com.trolltech.qt.core.QModelIndex index, QAbstractItemView.ScrollHint hint)` Scrolls the view if necessary to ensure that the item at `index` is visible.
`void` | `scrollToBottom()` Scrolls the view to the bottom.
`void` | `scrollToTop()` Scrolls the view to the top.
`void` | `selectAll()` Selects all item in the view.
`protected java.util.List` | `selectedIndexes()` This convenience function returns a list of all selected and non-hidden item indexes in the view.
`QAbstractItemView.SelectionBehavior` | `selectionBehavior()` This property holds which selection behavior the view uses.
`protected void` | `selectionChanged(QItemSelection selected, QItemSelection deselected)` This slot is called when the selection is changed.
`protected QItemSelectionModel.SelectionFlags` | `selectionCommand(com.trolltech.qt.core.QModelIndex index)` Returns the SelectionFlags to be used when updating a selection with to include the `index` specified.
`protected QItemSelectionModel.SelectionFlags` | `selectionCommand(com.trolltech.qt.core.QModelIndex index, QEvent event)` Returns the SelectionFlags to be used when updating a selection with to include the `index` specified.
`QAbstractItemView.SelectionMode` | `selectionMode()` This property holds which selection mode the view operates in.
`QItemSelectionModel` | `selectionModel()` Returns the current selection model.
`void` | `setAlternatingRowColors(boolean enable)` This property holds whether to draw the background using alternating colors.
`void` | `setAutoScroll(boolean enable)` This property holds whether autoscrolling in drag move events is enabled.
`void` | `setAutoScrollMargin(int margin)` This property holds the size of the area when auto scrolling is triggered.
`void` | `setCurrentIndex(com.trolltech.qt.core.QModelIndex index)` Sets the current item to be the item at `index`.
`protected void` | `setDirtyRegion(QRegion region)` Marks the given `region` as dirty and schedules it to be updated.
`void` | `setDragDropMode(QAbstractItemView.DragDropMode behavior)` This property holds the drag and drop event the view will act upon.
`void` | `setDragDropOverwriteMode(boolean overwrite)` This property holds the view's drag and drop behavior.
`void` | `setDragEnabled(boolean enable)` This property holds whether the view supports dragging of its own items.
`void` | `setDropIndicatorShown(boolean enable)` This property holds whether the drop indicator is shown when dragging items and dropping.
`void` | `setEditTriggers(QAbstractItemView.EditTrigger[] triggers)` This property holds which actions will initiate item editing.
`void` | `setEditTriggers(QAbstractItemView.EditTriggers triggers)` This property holds which actions will initiate item editing.
`void` | `setHorizontalScrollMode(QAbstractItemView.ScrollMode mode)` This property holds how the view scrolls its contents in the horizontal direction.
`void` | `setIconSize(QSize size)` This property holds the size of items.
`void` | `setIndexWidget(com.trolltech.qt.core.QModelIndex index, QWidget widget)` Sets the given `widget` on the item at the given `index`, passing the ownership of the widget to the viewport.
`void` | `setItemDelegate(QAbstractItemDelegate delegate)` Sets the item delegate for this view and its model to `delegate`.
`void` | `setItemDelegateForColumn(int column, QAbstractItemDelegate delegate)` Sets the given item `delegate` used by this view and model for the given `column`.
`void` | `setItemDelegateForRow(int row, QAbstractItemDelegate delegate)` Sets the given item `delegate` used by this view and model for the given `row`.
`void` | `setModel(QAbstractItemModel model)` Sets the `model` for the view to present.
`void` | `setRootIndex(com.trolltech.qt.core.QModelIndex index)` Sets the root item to the item at the given `index`.
`protected abstract void` | `setSelection(QRect rect, QItemSelectionModel.SelectionFlags command)` Applies the selection `flags` to the items in or touched by the rectangle, `rect`.
`void` | `setSelectionBehavior(QAbstractItemView.SelectionBehavior behavior)` This property holds which selection behavior the view uses.
`void` | `setSelectionMode(QAbstractItemView.SelectionMode mode)` This property holds which selection mode the view operates in.
`void` | `setSelectionModel(QItemSelectionModel selectionModel)` Sets the current selection model to the given `selectionModel`.
`protected void` | `setState(QAbstractItemView.State state)` Sets the item view's state to the given `state`.
`void` | `setTabKeyNavigation(boolean enable)` This property holds whether item navigation with tab and backtab is enabled.
`void` | `setTextElideMode(Qt.TextElideMode mode)` This property holds the the position of the ".
`void` | `setVerticalScrollMode(QAbstractItemView.ScrollMode mode)` This property holds how the view scrolls its contents in the vertical direction.
`boolean` | `showDropIndicator()` This property holds whether the drop indicator is shown when dragging items and dropping.
`int` | `sizeHintForColumn(int column)` Returns the width size hint for the specified `column` or -1 if there is no model.
`QSize` | `sizeHintForIndex(com.trolltech.qt.core.QModelIndex index)` Returns the size hint for the item with the specified `index` or an invalid size for invalid indexes.
`int` | `sizeHintForRow(int row)` Returns the height size hint for the specified `row` or -1 if there is no model.
`protected void` | `startDrag(Qt.DropAction[] supportedActions)` Starts a drag by calling drag->exec() using the given `supportedActions`.
`protected void` | `startDrag(Qt.DropActions supportedActions)` Starts a drag by calling drag->exec() using the given `supportedActions`.
`protected QAbstractItemView.State` | `state()` Returns the item view's state.
`boolean` | `tabKeyNavigation()` This property holds whether item navigation with tab and backtab is enabled.
`Qt.TextElideMode` | `textElideMode()` This property holds the the position of the ".
`void` | `update(com.trolltech.qt.core.QModelIndex index)` Updates the area occupied by the given `index`.
`protected void` | `updateGeometries()` Updates the geometry of the child widgets of the view.
`protected abstract int` | `verticalOffset()` Returns the vertical offset of the view.
`QAbstractItemView.ScrollMode` | `verticalScrollMode()` This property holds how the view scrolls its contents in the vertical direction.
`protected QStyleOptionViewItem` | `viewOptions()` Returns a `QStyleOptionViewItem` structure populated with the view's palette, font, state, alignments etc.
`abstract QRect` | `visualRect(com.trolltech.qt.core.QModelIndex index)` Returns the rectangle on the viewport occupied by the item at `index`.
`protected abstract QRegion` | `visualRegionForSelection(QItemSelection selection)` Returns the region from the viewport of the items in the given `selection`.

Methods inherited from class com.trolltech.qt.gui.QAbstractScrollArea
`addScrollBarWidget, addScrollBarWidget, cornerWidget, horizontalScrollBar, horizontalScrollBarPolicy, maximumViewportSize, scrollBarWidgets, scrollBarWidgets, scrollContentsBy, setCornerWidget, setHorizontalScrollBar, setHorizontalScrollBarPolicy, setupViewport, setVerticalScrollBar, setVerticalScrollBarPolicy, setViewport, setViewportMargins, verticalScrollBar, verticalScrollBarPolicy, viewport, viewportEvent`

Methods inherited from class com.trolltech.qt.gui.QFrame
`frameRect, frameShadow, frameShape, frameStyle, frameWidth, lineWidth, midLineWidth, setFrameRect, setFrameShadow, setFrameShape, setFrameStyle, setLineWidth, setMidLineWidth`

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, changeEvent, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuEvent, contextMenuPolicy, cursor, depth, destroy, destroy, destroy, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, effectiveWinId, ensurePolished, enterEvent, focusInEvent, focusNextChild, focusNextPrevChild, focusOutEvent, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isMaximized, isMinimized, isModal, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, keyPressEvent, keyReleaseEvent, languageChange, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumSizeHint, minimumWidth, mouseDoubleClickEvent, mouseGrabber, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, move, move, moveEvent, nativeParentWidget, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, paintEngine, paintEvent, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, resizeEvent, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFilePath, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showEvent, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeHint, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, wheelEvent, width, widthMM, window, windowFilePath, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### activated

    public final QSignalEmitter.Signal1 activated

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QModelIndex(named: index)>:

  This signal is emitted when the item specified by `index` is activated by the user. How to activate items depends on the platform; e.g., by single- or double-clicking the item, or by pressing the Return or Enter key when the item is current.

See also:
  `clicked()` , `doubleClicked()` , `entered()` , and `pressed()` .

### clicked

    public final QSignalEmitter.Signal1 clicked

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QModelIndex(named: index)>:

  This signal is emitted when a mouse button is clicked. The item the mouse was clicked on is specified by `index`. The signal is only emitted when the index is valid.

See also:
  `activated()` , `doubleClicked()` , `entered()` , and `pressed()` .

### doubleClicked

    public final QSignalEmitter.Signal1 doubleClicked

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QModelIndex(named: index)>:

  This signal is emitted when a mouse button is double-clicked. The item the mouse was double-clicked on is specified by `index`. The signal is only emitted when the index is valid.

See also:
  `clicked()` , and `activated()` .

### entered

    public final QSignalEmitter.Signal1 entered

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QModelIndex(named: index)>:

  This signal is emitted when the mouse cursor enters the item specified by `index`. Mouse tracking needs to be enabled for this feature to work.

See also:
  `viewportEntered()` , `activated()` , `clicked()` , `doubleClicked()` , and `pressed()` .

### pressed

    public final QSignalEmitter.Signal1 pressed

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QModelIndex(named: index)>:

  This signal is emitted when a mouse button is pressed. The item the mouse was pressed on is specified by `index`. The signal is only emitted when the index is valid.

  Use the `QApplication::mouseButtons()` function to get the state of the mouse buttons.

See also:
  `activated()` , `clicked()` , `doubleClicked()` , and `entered()` .

### viewportEntered

    public final QSignalEmitter.Signal0 viewportEntered

  This signal is emitted when the mouse cursor enters the viewport. Mouse tracking needs to be enabled for this feature to work.

See also:
  `entered()` .

Constructor Detail

### QAbstractItemView

    public QAbstractItemView()

  Constructs an abstract item view with the given `parent`.

### QAbstractItemView

    public QAbstractItemView(QWidget parent)

  Constructs an abstract item view with the given `parent`.

Method Detail

### alternatingRowColors

    public final boolean alternatingRowColors()

  This property holds whether to draw the background using alternating colors. If this property is true, the item background will be drawn using `QPalette::Base` and `QPalette::AlternateBase` ; otherwise the background will be drawn using the `QPalette::Base` color.

  By default, this property is false.

### autoScrollMargin

    public final int autoScrollMargin()

  This property holds the size of the area when auto scrolling is triggered. This property controlls the size of the area at the edge of the viewport that triggers autoscrolling. The default value is 16 pixels.

### clearSelection

    public final void clearSelection()

  Deselects all selected items. The current index will not be changed.

See also:
  `setSelection()`, and `selectAll()`.

### closePersistentEditor

    public final void closePersistentEditor(com.trolltech.qt.core.QModelIndex index)

  Closes the persistent editor for the item at the given `index`.

See also:
  `openPersistentEditor()`.

### currentIndex

    public final com.trolltech.qt.core.QModelIndex currentIndex()

  Returns the model index of the current item.

See also:
  `setCurrentIndex()`.

### dirtyRegionOffset

    protected final QPoint dirtyRegionOffset()

  Returns the offset of the dirty regions in the view.

  If you use `scrollDirtyRegion()` and implement a `paintEvent()` in a subclass of `QAbstractItemView`, you should translate the area given by the paint event with the offset returned from this function.

See also:
  `scrollDirtyRegion()`, and `setDirtyRegion()`.

### dragDropMode

    public final QAbstractItemView.DragDropMode dragDropMode()

  This property holds the drag and drop event the view will act upon.

See also:
  `showDropIndicator`, and `dragDropOverwriteMode`.

### dragDropOverwriteMode

    public final boolean dragDropOverwriteMode()

  This property holds the view's drag and drop behavior. If its value is `true`, the selected data will overwrite the existing item data when dropped, while moving the data will clear the item. If its value is `false`, the selected data will be inserted as a new item when the data is dropped. When the data is moved, the item is removed as well.

  The default value is `false`, as in the `QListView` and `QTreeView` subclasses. In the `QTableView` subclass, on the other hand, the property has been set to `true`.

  Note: This is not intended to prevent overwriting of items. The model's implementation of flags() should do that by not returning `Qt::ItemIsDropEnabled` .

See also:
  `dragDropMode`.

### dragEnabled

    public final boolean dragEnabled()

  This property holds whether the view supports dragging of its own items.

See also:
  `showDropIndicator`, `DragDropMode` , `dragDropOverwriteMode`, and `acceptDrops`.

### dropIndicatorPosition

    protected final QAbstractItemView.DropIndicatorPosition dropIndicatorPosition()

  Returns the position of the drop indicator in relation to the closest item.

### edit

    public final void edit(com.trolltech.qt.core.QModelIndex index)

  Starts editing the item corresponding to the given `index` if it is editable.

  Note that this function does not change the current index. Since the current index defines the next and previous items to edit, users may find that keyboard navigation does not work as expected. To provide consistent navigation behavior, call `setCurrentIndex()` before this function with the same model index.

See also:
  QModelIndex::flags().

### editTriggers

    public final QAbstractItemView.EditTriggers editTriggers()

  This property holds which actions will initiate item editing. This property is a selection of flags defined by `EditTrigger` , combined using the OR operator. The view will only initiate the editing of an item if the action performed is set in this property.

### executeDelayedItemsLayout

    protected final void executeDelayedItemsLayout()

  Executes the scheduled layouts without waiting for the event processing to begin.

See also:
  `scheduleDelayedItemsLayout()`.

### hasAutoScroll

    public final boolean hasAutoScroll()

  This property holds whether autoscrolling in drag move events is enabled. If this property is set to true (the default), the `QAbstractItemView` automatically scrolls the contents of the view if the user drags within 16 pixels of the viewport edge. If the current item changes, then the view will scroll automatically to ensure that the current item is fully visible.

  This property only works if the viewport accepts drops. Autoscroll is switched off by setting this property to false.

### horizontalScrollMode

    public final QAbstractItemView.ScrollMode horizontalScrollMode()

  This property holds how the view scrolls its contents in the horizontal direction. This property controlls how the view scroll its contents horizontally. Scrolling can be done either per pixel or per item.

### iconSize

    public final QSize iconSize()

  This property holds the size of items. Setting this property when the view is visible will cause the items to be laid out again.

### indexWidget

    public final QWidget indexWidget(com.trolltech.qt.core.QModelIndex index)

  Returns the widget for the item at the given `index`.

See also:
  `setIndexWidget()`.

### itemDelegate

    public final QAbstractItemDelegate itemDelegate()

  Returns the item delegate used by this view and model. This is either one set with `setItemDelegate()`, or the default one.

See also:
  `setItemDelegate()`.

### itemDelegate

    public final QAbstractItemDelegate itemDelegate(com.trolltech.qt.core.QModelIndex index)

  Returns the item delegate used by this view and model for the given `index`.

### itemDelegateForColumn

    public final QAbstractItemDelegate itemDelegateForColumn(int column)

  Returns the item delegate used by this view and model for the given `column`. You can call `itemDelegate()` to get a pointer to the current delegate for a given index.

See also:
  `setItemDelegateForColumn()`, `itemDelegateForRow()`, and `itemDelegate()`.

### itemDelegateForRow

    public final QAbstractItemDelegate itemDelegateForRow(int row)

  Returns the item delegate used by this view and model for the given `row`, or 0 if no delegate has been assigned. You can call `itemDelegate()` to get a pointer to the current delegate for a given index.

See also:
  `setItemDelegateForRow()`, `itemDelegateForColumn()`, and `setItemDelegate()`.

### model

    public final QAbstractItemModel model()

  Returns the model that this view is presenting.

See also:
  `setModel()`.

### openPersistentEditor

    public final void openPersistentEditor(com.trolltech.qt.core.QModelIndex index)

  Opens a persistent editor on the item at the given `index`. If no editor exists, the delegate will create a new editor.

See also:
  `closePersistentEditor()`.

### rootIndex

    public final com.trolltech.qt.core.QModelIndex rootIndex()

  Returns the model index of the model's root item. The root item is the parent item to the view's toplevel items. The root can be invalid.

See also:
  `setRootIndex()`.

### scheduleDelayedItemsLayout

    protected final void scheduleDelayedItemsLayout()

  Schedules a layout of the items in the view to be executed when the event processing starts.

  Even if `scheduleDelayedItemsLayout()` is called multiple times before events are processed, the view will only do the layout once.

See also:
  `executeDelayedItemsLayout()`.

### scrollDirtyRegion

    protected final void scrollDirtyRegion(int dx,
                                           int dy)

  Prepares the view for scrolling by (`dx`,`dy`) pixels by moving the dirty regions in the opposite direction. You only need to call this function if you are implementing a scrolling viewport in your view subclass.

  If you implement `scrollContentsBy()` in a subclass of `QAbstractItemView`, call this function before you call `QWidget::scroll()` on the viewport. Alternatively, just call `update()`.

See also:
  `scrollContentsBy()`, `dirtyRegionOffset()`, and `setDirtyRegion()`.

### scrollToBottom

    public final void scrollToBottom()

  Scrolls the view to the bottom.

See also:
  `scrollTo()`, and `scrollToTop()`.

### scrollToTop

    public final void scrollToTop()

  Scrolls the view to the top.

See also:
  `scrollTo()`, and `scrollToBottom()`.

### selectionBehavior

    public final QAbstractItemView.SelectionBehavior selectionBehavior()

  This property holds which selection behavior the view uses. This property holds whether selections are done in terms of single items, rows or columns.

See also:
  `SelectionMode` , and `SelectionBehavior` .

### selectionMode

    public final QAbstractItemView.SelectionMode selectionMode()

  This property holds which selection mode the view operates in. This property controls whether the user can select one or many items and, in many-item selections, whether the selection must be a continuous range of items.

See also:
  `SelectionMode` , and `SelectionBehavior` .

### selectionModel

    public final QItemSelectionModel selectionModel()

  Returns the current selection model.

See also:
  `setSelectionModel()`, and `selectedIndexes()`.

### setAlternatingRowColors

    public final void setAlternatingRowColors(boolean enable)

  This property holds whether to draw the background using alternating colors. If this property is true, the item background will be drawn using `QPalette::Base` and `QPalette::AlternateBase` ; otherwise the background will be drawn using the `QPalette::Base` color.

  By default, this property is false.

### setAutoScroll

    public final void setAutoScroll(boolean enable)

  This property holds whether autoscrolling in drag move events is enabled. If this property is set to true (the default), the `QAbstractItemView` automatically scrolls the contents of the view if the user drags within 16 pixels of the viewport edge. If the current item changes, then the view will scroll automatically to ensure that the current item is fully visible.

  This property only works if the viewport accepts drops. Autoscroll is switched off by setting this property to false.

### setAutoScrollMargin

    public final void setAutoScrollMargin(int margin)

  This property holds the size of the area when auto scrolling is triggered. This property controlls the size of the area at the edge of the viewport that triggers autoscrolling. The default value is 16 pixels.

### setCurrentIndex

    public final void setCurrentIndex(com.trolltech.qt.core.QModelIndex index)

  Sets the current item to be the item at `index`. Depending on the current selection mode, the item may also be selected. Note that this function also updates the starting position for any new selections the user performs.

  To set an item as the current item without selecting it, call

  `selectionModel()->setCurrentIndex(index, QItemSelectionModel::NoUpdate);`

See also:
  `currentIndex()`, `currentChanged()`, and `selectionMode`.

### setDirtyRegion

    protected final void setDirtyRegion(QRegion region)

  Marks the given `region` as dirty and schedules it to be updated. You only need to call this function if you are implementing your own view subclass.

See also:
  `scrollDirtyRegion()`, and `dirtyRegionOffset()`.

### setDragDropMode

    public final void setDragDropMode(QAbstractItemView.DragDropMode behavior)

  This property holds the drag and drop event the view will act upon.

See also:
  `showDropIndicator`, and `dragDropOverwriteMode`.

### setDragDropOverwriteMode

    public final void setDragDropOverwriteMode(boolean overwrite)

  This property holds the view's drag and drop behavior. If its value is `true`, the selected data will overwrite the existing item data when dropped, while moving the data will clear the item. If its value is `false`, the selected data will be inserted as a new item when the data is dropped. When the data is moved, the item is removed as well.

  The default value is `false`, as in the `QListView` and `QTreeView` subclasses. In the `QTableView` subclass, on the other hand, the property has been set to `true`.

  Note: This is not intended to prevent overwriting of items. The model's implementation of flags() should do that by not returning `Qt::ItemIsDropEnabled` .

See also:
  `dragDropMode`.

### setDragEnabled

    public final void setDragEnabled(boolean enable)

  This property holds whether the view supports dragging of its own items.

See also:
  `showDropIndicator`, `DragDropMode` , `dragDropOverwriteMode`, and `acceptDrops`.

### setDropIndicatorShown

    public final void setDropIndicatorShown(boolean enable)

  This property holds whether the drop indicator is shown when dragging items and dropping.

See also:
  `dragEnabled`, `DragDropMode` , `dragDropOverwriteMode`, and `acceptDrops`.

### setEditTriggers

    public final void setEditTriggers(QAbstractItemView.EditTrigger[] triggers)

  This property holds which actions will initiate item editing. This property is a selection of flags defined by `EditTrigger` , combined using the OR operator. The view will only initiate the editing of an item if the action performed is set in this property.

### setEditTriggers

    public final void setEditTriggers(QAbstractItemView.EditTriggers triggers)

  This property holds which actions will initiate item editing. This property is a selection of flags defined by `EditTrigger` , combined using the OR operator. The view will only initiate the editing of an item if the action performed is set in this property.

### setHorizontalScrollMode

    public final void setHorizontalScrollMode(QAbstractItemView.ScrollMode mode)

  This property holds how the view scrolls its contents in the horizontal direction. This property controlls how the view scroll its contents horizontally. Scrolling can be done either per pixel or per item.

### setIconSize

    public final void setIconSize(QSize size)

  This property holds the size of items. Setting this property when the view is visible will cause the items to be laid out again.

### setIndexWidget

    public final void setIndexWidget(com.trolltech.qt.core.QModelIndex index,
                                     QWidget widget)

  Sets the given `widget` on the item at the given `index`, passing the ownership of the widget to the viewport.

  If `index` is invalid (e.g., if you pass the root index), this function will do nothing.

  Note that the given `widget`'s `autoFillBackground` property must be set to true, otherwise the widget's background will be transparent, showing both the model data and the item at the given `index`.

  This function should only be used to display static content within the visible area corresponding to an item of data. If you want to display custom dynamic content or implement a custom editor widget, subclass `QItemDelegate` instead.

See also:
  `indexWidget()`, and Delegate Classes.

### setItemDelegate

    public final void setItemDelegate(QAbstractItemDelegate delegate)

  Sets the item delegate for this view and its model to `delegate`. This is useful if you want complete control over the editing and display of items.

  Any existing delegate will be removed, but not deleted. `QAbstractItemView` does not take ownership of `delegate`.

  Warning: You should not share the same instance of a delegate between views. Doing so can cause incorrect or unintuitive editing behavior since each view connected to a given delegate may receive the `closeEditor()` signal, and attempt to access, modify or close an editor that has already been closed.

See also:
  `itemDelegate()`.

### setItemDelegateForColumn

    public final void setItemDelegateForColumn(int column,
                                               QAbstractItemDelegate delegate)

  Sets the given item `delegate` used by this view and model for the given `column`. All items on `column` will be drawn and managed by `delegate` instead of using the default delegate (i.e., `itemDelegate()`).

  Any existing column delegate for `column` will be removed, but not deleted. `QAbstractItemView` does not take ownership of `delegate`.

  Note: If a delegate has been assigned to both a row and a column, the row delegate will take presedence and manage the intersecting cell index.

  Warning: You should not share the same instance of a delegate between views. Doing so can cause incorrect or unintuitive editing behavior since each view connected to a given delegate may receive the `closeEditor()` signal, and attempt to access, modify or close an editor that has already been closed.

See also:
  `itemDelegateForColumn()`, `setItemDelegateForRow()`, and `itemDelegate()`.

### setItemDelegateForRow

    public final void setItemDelegateForRow(int row,
                                            QAbstractItemDelegate delegate)

  Sets the given item `delegate` used by this view and model for the given `row`. All items on `row` will be drawn and managed by `delegate` instead of using the default delegate (i.e., `itemDelegate()`).

  Any existing row delegate for `row` will be removed, but not deleted. `QAbstractItemView` does not take ownership of `delegate`.

  Note: If a delegate has been assigned to both a row and a column, the row delegate (i.e., this delegate) will take presedence and manage the intersecting cell index.

  Warning: You should not share the same instance of a delegate between views. Doing so can cause incorrect or unintuitive editing behavior since each view connected to a given delegate may receive the `closeEditor()` signal, and attempt to access, modify or close an editor that has already been closed.

See also:
  `itemDelegateForRow()`, `setItemDelegateForColumn()`, and `itemDelegate()`.

### setSelectionBehavior

    public final void setSelectionBehavior(QAbstractItemView.SelectionBehavior behavior)

  This property holds which selection behavior the view uses. This property holds whether selections are done in terms of single items, rows or columns.

See also:
  `SelectionMode` , and `SelectionBehavior` .

### setSelectionMode

    public final void setSelectionMode(QAbstractItemView.SelectionMode mode)

  This property holds which selection mode the view operates in. This property controls whether the user can select one or many items and, in many-item selections, whether the selection must be a continuous range of items.

See also:
  `SelectionMode` , and `SelectionBehavior` .

### setState

    protected final void setState(QAbstractItemView.State state)

  Sets the item view's state to the given `state`.

See also:
  `state()`.

### setTabKeyNavigation

    public final void setTabKeyNavigation(boolean enable)

  This property holds whether item navigation with tab and backtab is enabled.

### setTextElideMode

    public final void setTextElideMode(Qt.TextElideMode mode)

  This property holds the the position of the ". ." in elided text.. The default value for all item views is `Qt::ElideRight` .

### setVerticalScrollMode

    public final void setVerticalScrollMode(QAbstractItemView.ScrollMode mode)

  This property holds how the view scrolls its contents in the vertical direction. This property controlls how the view scroll its contents vertically. Scrolling can be done either per pixel or per item.

### showDropIndicator

    public final boolean showDropIndicator()

  This property holds whether the drop indicator is shown when dragging items and dropping.

See also:
  `dragEnabled`, `DragDropMode` , `dragDropOverwriteMode`, and `acceptDrops`.

### sizeHintForIndex

    public final QSize sizeHintForIndex(com.trolltech.qt.core.QModelIndex index)

  Returns the size hint for the item with the specified `index` or an invalid size for invalid indexes.

See also:
  `sizeHintForRow()`, and `sizeHintForColumn()`.

### state

    protected final QAbstractItemView.State state()

  Returns the item view's state.

See also:
  `setState()`.

### tabKeyNavigation

    public final boolean tabKeyNavigation()

  This property holds whether item navigation with tab and backtab is enabled.

### textElideMode

    public final Qt.TextElideMode textElideMode()

  This property holds the the position of the ". ." in elided text.. The default value for all item views is `Qt::ElideRight` .

### update

    public final void update(com.trolltech.qt.core.QModelIndex index)

  Updates the area occupied by the given `index`.

### verticalScrollMode

    public final QAbstractItemView.ScrollMode verticalScrollMode()

  This property holds how the view scrolls its contents in the vertical direction. This property controlls how the view scroll its contents vertically. Scrolling can be done either per pixel or per item.

### closeEditor

    protected void closeEditor(QWidget editor,
                               QAbstractItemDelegate.EndEditHint hint)

  Closes the given `editor`, and releases it. The `hint` is used to specify how the view should respond to the end of the editing operation. For example, the hint may indicate that the next item in the view should be opened for editing.

See also:
  `edit()`, and `commitData()`.

### commitData

    protected void commitData(QWidget editor)

  Commit the data in the `editor` to the model.

See also:
  `closeEditor()`.

### currentChanged

    protected void currentChanged(com.trolltech.qt.core.QModelIndex current,
                                  com.trolltech.qt.core.QModelIndex previous)

  This slot is called when a new item becomes the current item. The previous current item is specified by the `previous` index, and the new item by the `current` index.

  If you want to know about changes to items see the `dataChanged()` signal.

### dataChanged

    protected void dataChanged(com.trolltech.qt.core.QModelIndex topLeft,
                               com.trolltech.qt.core.QModelIndex bottomRight)

  This slot is called when items are changed in the model. The changed items are those from `topLeft` to `bottomRight` inclusive. If just one item is changed `topLeft` == `bottomRight`.

### edit

    protected boolean edit(com.trolltech.qt.core.QModelIndex index,
                           QAbstractItemView.EditTrigger trigger,
                           QEvent event)

  Starts editing the item at `index`, creating an editor if necessary, and returns true if the view's `State` is now `EditingState` ; otherwise returns false.

  The action that caused the editing process is described by `trigger`, and the associated event is specified by `event`.

  Editing can be forced by specifying the `trigger` to be `QAbstractItemView::AllEditTriggers` .

See also:
  `closeEditor()`.

### editorDestroyed

    protected void editorDestroyed(QObject editor)

  This function is called when the given `editor` has been destroyed.

See also:
  `closeEditor()`.

### horizontalOffset

    protected abstract int horizontalOffset()

  Returns the horizontal offset of the view.

  In the base class this is a pure virtual function.

See also:
  `verticalOffset()`.

### indexAt

    public abstract com.trolltech.qt.core.QModelIndex indexAt(QPoint point)

  Returns the model index of the item at the viewport coordinates `point`.

  In the base class this is a pure virtual function.

See also:
  `visualRect()`.

### isIndexHidden

    protected abstract boolean isIndexHidden(com.trolltech.qt.core.QModelIndex index)

  Returns true if the item referred to by the given `index` is hidden in the view, otherwise returns false.

  Hiding is a view specific feature. For example in TableView a column can be marked as hidden or a row in the TreeView.

  In the base class this is a pure virtual function.

### keyboardSearch

    public void keyboardSearch(java.lang.String search)

  Moves to and selects the item best matching the string `search`. If no item is found nothing happens.

  In the default implementation, the search is reset if `search` is empty, or the time interval since the last search has exceeded `QApplication::keyboardInputInterval()`.

### moveCursor

    protected abstract com.trolltech.qt.core.QModelIndex moveCursor(QAbstractItemView.CursorAction cursorAction,
                                                                    Qt.KeyboardModifiers modifiers)

  Returns a QModelIndex object pointing to the next object in the view, based on the given `cursorAction` and keyboard modifiers specified by `modifiers`.

  In the base class this is a pure virtual function.

### reset

    public void reset()

  Reset the internal state of the view.

  Warning: This function will reset open editors, scroll bar positions, selections, etc. Existing changes will not be committed. If you would like to save your changes when resetting the view, you can reimplement this function, commit your changes, and then call the superclass' implementation.

### rowsAboutToBeRemoved

    protected void rowsAboutToBeRemoved(com.trolltech.qt.core.QModelIndex parent,
                                        int start,
                                        int end)

  This slot is called when rows are about to be removed. The deleted rows are those under the given `parent` from `start` to `end` inclusive.

See also:
  `rowsInserted()`.

### rowsInserted

    protected void rowsInserted(com.trolltech.qt.core.QModelIndex parent,
                                int start,
                                int end)

  This slot is called when rows are inserted. The new rows are those under the given `parent` from `start` to `end` inclusive. The base class implementation calls fetchMore() on the model to check for more data.

See also:
  `rowsAboutToBeRemoved()`.

### scrollTo

    public final void scrollTo(com.trolltech.qt.core.QModelIndex index)

  Scrolls the view if necessary to ensure that the item at `index` is visible. The view will try to position the item according to the given `hint`.

  In the base class this is a pure virtual function.

### scrollTo

    public abstract void scrollTo(com.trolltech.qt.core.QModelIndex index,
                                  QAbstractItemView.ScrollHint hint)

  Scrolls the view if necessary to ensure that the item at `index` is visible. The view will try to position the item according to the given `hint`.

  In the base class this is a pure virtual function.

### selectAll

    public void selectAll()

  Selects all item in the view. This function wil use the selection selection behavior set on the view when selecting.

See also:
  `setSelection()`, `selectedIndexes()`, and `clearSelection()`.

### selectedIndexes

    protected java.util.List selectedIndexes()

  This convenience function returns a list of all selected and non-hidden item indexes in the view. The list contains no duplicates, and is not sorted.

  The default implementation does nothing.

See also:
  `QItemSelectionModel::selectedIndexes()`.

### selectionChanged

    protected void selectionChanged(QItemSelection selected,
                                    QItemSelection deselected)

  This slot is called when the selection is changed. The previous selection (which may be empty), is specified by `deselected`, and the new selection by `selected`.

See also:
  `setSelection()`.

### selectionCommand

    protected final QItemSelectionModel.SelectionFlags selectionCommand(com.trolltech.qt.core.QModelIndex index)

  Returns the SelectionFlags to be used when updating a selection with to include the `index` specified. The `event` is a user input event, such as a mouse or keyboard event.

  Reimplement this function to define your own selection behavior.

See also:
  `setSelection()`.

### selectionCommand

    protected QItemSelectionModel.SelectionFlags selectionCommand(com.trolltech.qt.core.QModelIndex index,
                                                                  QEvent event)

  Returns the SelectionFlags to be used when updating a selection with to include the `index` specified. The `event` is a user input event, such as a mouse or keyboard event.

  Reimplement this function to define your own selection behavior.

See also:
  `setSelection()`.

### setModel

    public void setModel(QAbstractItemModel model)

  Sets the `model` for the view to present.

  Note: The view does not take ownership of the model unless it is the model's parent object because it may be shared between many different views.

  Note: This function will also create and set a new selection model, replacing any previously set with `setSelectionModel()`, but the old selection model will not be deleted.

See also:
  `model()`, `selectionModel()`, and `setSelectionModel()`.

### setRootIndex

    public void setRootIndex(com.trolltech.qt.core.QModelIndex index)

  Sets the root item to the item at the given `index`.

See also:
  `rootIndex()`.

### setSelection

    protected abstract void setSelection(QRect rect,
                                         QItemSelectionModel.SelectionFlags command)

  Applies the selection `flags` to the items in or touched by the rectangle, `rect`.

  When implementing your own itemview setSelection should call `selectionModel()`->select(selection, flags) where selection is either an empty QModelIndex or a `QItemSelection` that contains all items that are contained in `rect`.

See also:
  `selectionCommand()`, and `selectedIndexes()`.

### setSelectionModel

    public void setSelectionModel(QItemSelectionModel selectionModel)

  Sets the current selection model to the given `selectionModel`.

  Note that, if you call `setModel()` after this function, the given `selectionModel` will be replaced by one created by the view.

See also:
  `selectionModel()`, `setModel()`, and `clearSelection()`.

### sizeHintForColumn

    public int sizeHintForColumn(int column)

  Returns the width size hint for the specified `column` or -1 if there is no model.

  This function is used in views with a horizontal header to find the size hint for a header section based on the contents of the given `column`.

See also:
  `sizeHintForRow()`.

### sizeHintForRow

    public int sizeHintForRow(int row)

  Returns the height size hint for the specified `row` or -1 if there is no model.

  The returned height is calculated using the size hints of the given `row`'s items, i.e. the returned value is the maximum height among the items. Note that to control the height of a row, you must reimplement the `QAbstractItemDelegate::sizeHint()` function.

  This function is used in views with a vertical header to find the size hint for a header section based on the contents of the given `row`.

See also:
  `sizeHintForColumn()`.

### startDrag

    protected final void startDrag(Qt.DropAction[] supportedActions)

  Starts a drag by calling drag->exec() using the given `supportedActions`.

### startDrag

    protected void startDrag(Qt.DropActions supportedActions)

  Starts a drag by calling drag->exec() using the given `supportedActions`.

### updateGeometries

    protected void updateGeometries()

  Updates the geometry of the child widgets of the view.

### verticalOffset

    protected abstract int verticalOffset()

  Returns the vertical offset of the view.

  In the base class this is a pure virtual function.

See also:
  `horizontalOffset()`.

### viewOptions

    protected QStyleOptionViewItem viewOptions()

  Returns a `QStyleOptionViewItem` structure populated with the view's palette, font, state, alignments etc.

### visualRect

    public abstract QRect visualRect(com.trolltech.qt.core.QModelIndex index)

  Returns the rectangle on the viewport occupied by the item at `index`.

  If your item is displayed in several areas then visualRect should return the primary area that contains index and not the complete area that index might encompasses, touch or cause drawing.

  In the base class this is a pure virtual function.

See also:
  `indexAt()`, and `visualRegionForSelection()`.

### visualRegionForSelection

    protected abstract QRegion visualRegionForSelection(QItemSelection selection)

  Returns the region from the viewport of the items in the given `selection`.

  In the base class this is a pure virtual function.

See also:
  `visualRect()`, and `selectedIndexes()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD